/** 
* Variables
*/ 
	var selectedConversionType = '';
	var selectedIndexFromDrop =  '';
	var selectedIndexToDrop =  '';
	var selectedInputValue = '';
	var isValidInput = true;
	var isAlreadyEdited = false;

/*
 * Constants 
 */
	// Conversion Types definition
	var TYPE_ANGLE 		 = webui.i18n.localize("Angle");
	var TYPE_AREA 		 = webui.i18n.localize("Area");
	var TYPE_DISTANCE 	 = webui.i18n.localize("Distance");
	var TYPE_MASS 		 = webui.i18n.localize("Mass");
	var TYPE_NUMBER_BASE = webui.i18n.localize("Number Base");
	var TYPE_SPEED 		 = webui.i18n.localize("Speed");
	var TYPE_TEMPERATURE = webui.i18n.localize("Temperature");
	var TYPE_VOLUME 	 = webui.i18n.localize("Volume");
	var TYPE_NC_HEX 	 = webui.i18n.localize("hexadecimal");
	var TYPE_NC_DEC 	 = webui.i18n.localize("decimal");
	var TYPE_NC_OCT 	 = webui.i18n.localize("octal");
	var TYPE_NC_BIN 	 = webui.i18n.localize("binary");
	
	// Error messages
	var ERR_INVALID_INPUT  = webui.i18n.localize("invalid input");
	var ERR_RESULT_TOOLONG = webui.i18n.localize('result too long');
	
	// Others 
	var MAX_LENGTH = 10;
	var DEF_DECIMAL_SEP	 = '.';
	var KEY_CODE_CENTER = 13; // Key code for center soft key
	

/** 
* Conversion types array initialization
*/ 
	var converterTypes = new Object();
	
	//Angle 
	converterTypes[TYPE_ANGLE] = new Array();
	converterTypes[TYPE_ANGLE][0] = "";
	converterTypes[TYPE_ANGLE][1]= webui.i18n.localize('degrees') + ',1E+11';
	converterTypes[TYPE_ANGLE][2]= webui.i18n.localize('radians') + ',1.74532925199433E+9';
	//converterTypes[TYPE_ANGLE][3]= webui.i18n.localize('grads') + ',1.11111111111111E+11';
	
	// Area 
	converterTypes[TYPE_AREA] = new Array();
	converterTypes[TYPE_AREA][0] = "";
	converterTypes[TYPE_AREA][1] = webui.i18n.localize('square millimeters') + ',1E+21';
	converterTypes[TYPE_AREA][2] = webui.i18n.localize('square centimeters') + ',1E+19';
	converterTypes[TYPE_AREA][3] = webui.i18n.localize('square meters') + ',1E+15';
	converterTypes[TYPE_AREA][4] = webui.i18n.localize('square kilometers') + ',1E+9';
	converterTypes[TYPE_AREA][5] = webui.i18n.localize('square inches') + ',1.5500031000062E+18';
	converterTypes[TYPE_AREA][6] = webui.i18n.localize('square feet') + ',1.07639104167097E+16';
	converterTypes[TYPE_AREA][7] = webui.i18n.localize('square yards') + ',1.19599004630108E+15';
	converterTypes[TYPE_AREA][8] = webui.i18n.localize('square miles') + ',3.86102158542446E+8';
	converterTypes[TYPE_AREA][9] = webui.i18n.localize('acres') + ',2.47105381467165E+11';
	converterTypes[TYPE_AREA][10] = webui.i18n.localize('hectares') + ',1E+11';
	
	// Lenght  
	converterTypes[TYPE_DISTANCE] = new Array();
	converterTypes[TYPE_DISTANCE][0] = "";
	converterTypes[TYPE_DISTANCE][1] = webui.i18n.localize('millimeters') + ',1E+34';
	converterTypes[TYPE_DISTANCE][2] = webui.i18n.localize('centimeters') + ',1E+33';
	converterTypes[TYPE_DISTANCE][3] = webui.i18n.localize('meters') + ',1E+31';
	converterTypes[TYPE_DISTANCE][4] = webui.i18n.localize('kilometers') + ',1E+28';
	converterTypes[TYPE_DISTANCE][5] = webui.i18n.localize('inches') + ',3.93700787401575E+32';
	converterTypes[TYPE_DISTANCE][6] = webui.i18n.localize('feet') + ',3.28083989501312E+31';
	converterTypes[TYPE_DISTANCE][7] = webui.i18n.localize('yards') + ',1.09361329833771E+31';
	converterTypes[TYPE_DISTANCE][8] = webui.i18n.localize('miles') + ',6.21371192237334E+27';
	converterTypes[TYPE_DISTANCE][9] = webui.i18n.localize('nautical miles') + ',5.39956803455724E+27'; //nautical mile (UK)",5.39611824837685E+27
	
	// Weight  
	/*
	converterTypes[TYPE_MASS][] = webui.i18n.localize('micrograms') + ',1E+24';
	converterTypes[TYPE_MASS][] = webui.i18n.localize('stones') + ',1.76369809747902E+14';
	converterTypes[TYPE_MASS][] = webui.i18n.localize('milligrams') + ',1E+21';*/
	converterTypes[TYPE_MASS] = new Array();
	converterTypes[TYPE_MASS][0] = "";
	converterTypes[TYPE_MASS][1] = webui.i18n.localize('grams') + ',1E+18';
	converterTypes[TYPE_MASS][2] = webui.i18n.localize('kilograms') + ',1E+15';
	converterTypes[TYPE_MASS][3] = webui.i18n.localize('tonnes') + ',1E+12';
	converterTypes[TYPE_MASS][4] = webui.i18n.localize('ounces') + ',3.52739619495804E+16';
	converterTypes[TYPE_MASS][5] = webui.i18n.localize('pounds') + ',2.20462262184878E+15';
	
	// Number base 
	converterTypes[TYPE_NUMBER_BASE] = new Array();
	converterTypes[TYPE_NUMBER_BASE][0] = "";
	converterTypes[TYPE_NUMBER_BASE][1] = TYPE_NC_DEC + ',x';
	converterTypes[TYPE_NUMBER_BASE][2] = TYPE_NC_BIN + ',x';
	converterTypes[TYPE_NUMBER_BASE][3] = TYPE_NC_OCT + ',x';
	converterTypes[TYPE_NUMBER_BASE][4] = TYPE_NC_HEX + ',x';
	
	// Speed 
	/*
	converterTypes[TYPE_SPEED][] = webui.i18n.localize('Kilometres per Second') + ',2.77777777777778E+9';
	converterTypes[TYPE_SPEED][] = webui.i18n.localize('Miles per Second') + ',1.72603108954815E+9';
	converterTypes[TYPE_SPEED][] = webui.i18n.localize('miles per hour') + ',6.21371192237334E+12';
	converterTypes[TYPE_SPEED][] = webui.i18n.localize('miles per minute') + ',1.03561865372889E+11';
	converterTypes[TYPE_SPEED][] = webui.i18n.localize('kilometres per minute') + ',1.66666666666667E+11';*/
	converterTypes[TYPE_SPEED] = new Array();
	converterTypes[TYPE_SPEED][0] = "";
	converterTypes[TYPE_SPEED][1] = webui.i18n.localize('kilometers per hour') + ',1E+13';
	converterTypes[TYPE_SPEED][2] = webui.i18n.localize('miles per hour') + ',6.21371192237334E+12';
	converterTypes[TYPE_SPEED][3] = webui.i18n.localize('nautical miles per hour') + ',5.39956803455724E+12'; //knots
	
	// Temperature
	converterTypes[TYPE_TEMPERATURE] = new Array();
	converterTypes[TYPE_TEMPERATURE][0] = "";
	converterTypes[TYPE_TEMPERATURE][1] = 'Celsius' + ',x';
	converterTypes[TYPE_TEMPERATURE][2] = 'Farenheit' + ',x';
	converterTypes[TYPE_TEMPERATURE][3] = 'Kelvin' + ',x';
	
	// Volume      
	/* 
	converterTypes[TYPE_VOLUME][]  = webui.i18n.localize('Cubic millimeter') + ',1E+19';
	converterTypes[TYPE_VOLUME][]  = webui.i18n.localize('Pints (US)') + ',2.11337641886519E+13';   //pint (UK) 1.7597539863927E+13
	converterTypes[TYPE_VOLUME][]  = webui.i18n.localize('Quarts (US)') + ',1.05668820943259E+13';  //quart (UK) 8.79876993196351E+12*/
	converterTypes[TYPE_VOLUME] = new Array();
	converterTypes[TYPE_VOLUME][0] = "";
	converterTypes[TYPE_VOLUME][1] = webui.i18n.localize('milliliters') + ',1E+16';
	converterTypes[TYPE_VOLUME][2] = webui.i18n.localize('liters') + ',1E+13';
	converterTypes[TYPE_VOLUME][3] = webui.i18n.localize('cubic centimeters') + ',1E+16';
	converterTypes[TYPE_VOLUME][4] = webui.i18n.localize('cubic meters') + ',1E+13'; // equivalent to 1 liter
	converterTypes[TYPE_VOLUME][5] = webui.i18n.localize('ounces') + ',3.3814022701843E+14';
	converterTypes[TYPE_VOLUME][6] = webui.i18n.localize('gallons') + ',2.64172052358148E+12'; //gallon (UK) 2.19969248299088E+12 
	converterTypes[TYPE_VOLUME][7] = webui.i18n.localize('cubic inches') + ',6.10237440947322E+14';
	converterTypes[TYPE_VOLUME][8] = webui.i18n.localize('cubic feet') + ',3.53146667214886E+11';
	converterTypes[TYPE_VOLUME][9] = webui.i18n.localize('cubic yards') + ',1.30795061931439E+10';


 
/**
* Loads a menu 
*/
function loadMenu(context) {

	skMenu = webui.softKeys.loadMenu(context);
	skMenu.addListener(listener);
    webui.softKeys.setActiveMenu(skMenu);
}

/**
* Fills dropdowns contents
*/
function fillTypeDropDown() {

	var objectTypeDropDown = document.getElementById("settingsTypeDropDown");
	
	objectTypeDropDown.options[0] = "";
	objectTypeDropDown.options[1] = new Option(TYPE_ANGLE);
	objectTypeDropDown.options[2] = new Option(TYPE_AREA);
	objectTypeDropDown.options[3] = new Option(TYPE_DISTANCE);
	objectTypeDropDown.options[4] = new Option(TYPE_MASS);
	objectTypeDropDown.options[5] = new Option(TYPE_NUMBER_BASE);
	objectTypeDropDown.options[6] = new Option(TYPE_SPEED);
	objectTypeDropDown.options[7] = new Option(TYPE_TEMPERATURE);
	objectTypeDropDown.options[8] = new Option(TYPE_VOLUME);
	objectTypeDropDown.focus();
}

/**
*  In case all parameters are filled, calculate menu is shown. Otherwise shows default context
*/
function changeContext(){
	
	var newIndexTypeOption = settingsTypeDropDown.options.selectedIndex; 
	var newIndexFromDrop = settingsFromDropDown.options.selectedIndex; 
	var newIndexToDrop = settingsToDropDown.options.selectedIndex;
	var tempInputValue = settingsValueInput.value;
	
	if ( !isValidInput ) {
	
		//println( "changeContext() reset menu" );
		//loadMenu("reset");
		loadMenu("default");
	}	
	else if ( newIndexTypeOption > 0 && newIndexFromDrop > 0 && newIndexToDrop > 0 && trim(tempInputValue) != "") {  
		
		//println( "changeContext() calculate menu" );	
		loadMenu("calculate");
	}
	else { 
	
		//println( "changeContext() default menu" );
		loadMenu("default");
	}
}

/**
 * Handle the WebUI container events.
 */
function onLoadAction(){
	
	//  onLaunch occurs when:
	//	1) The user initially launches the widget, or
	// 	2) The user reactivates the widget after deactivating it
	webui.onLaunch = onLaunchAction;
	
	//  onViewSwitch occurs when the user moves from livecon 
	//  to detailed view, or the reverse	
	webui.onViewSwitch = onViewSwitchAction;
	
    // Fills type drop down list 
    fillTypeDropDown();
    
}

/**
* Check which view is requested when the widget is launched and display it.
*/
function onLaunchAction(){

 try {
    
	 	println( "Writing to the livecon .. " );
    	
		switch(webui.viewType){
			
			// Detailed view
			case webui.defs.viewType.DETAILED_VIEW:
				document.getElementById("detailed-view").style.display = "block";
				//fillTypeDropDown();
				break;
			
			// Livecon view
			case webui.defs.viewType.LIVECON_VIEW:
				document.getElementById("livecon-view").style.display = "block";
				break;
		}
		
	} catch (e) {
	  println( e.message );
	}
}	


/**
* Switch between the livecon and detailed view.
*/
function onViewSwitchAction(){

    switch(webui.viewType){
          
    	// Detailed view
    	case webui.defs.viewType.DETAILED_VIEW:
    		document.getElementById("livecon-view").style.display = "none";
    		document.getElementById("detailed-view").style.display = "block";
            break; 
         
        // Livecon view      
        case webui.defs.viewType.LIVECON_VIEW:
        	document.getElementById("detailed-view").style.display = "none";
        	document.getElementById("livecon-view").style.display = "block";
			break;
    }
}

/**
* handleOnChangeTypeDropDown 
* fills From/To dropdowns
*/
function handleOnChangeTypeDropDown(textTypeDropDown)
{
	var objectFromDropDown = document.getElementById("settingsFromDropDown");
	var objectToDropDown = document.getElementById("settingsToDropDown");
	
	//println("Type antigo:'"+ selectedConversionType + "'  atual:'" + textTypeDropDown + "'");

    if ((selectedConversionType != textTypeDropDown)) {
        
        selectedConversionType = textTypeDropDown;         
		selectedIndexFromDrop =  '';
		selectedIndexToDrop =  '';
        
        // clears result field 
        document.getElementById("result").innerHTML = "";
        
		// clears combos contents 
		objectFromDropDown.options.length = 0;
		objectToDropDown.options.length = 0;
		
		if ( textTypeDropDown != "" ) {
		 
			// fills combos contents with text and value attributes 
		    for (var i = 0; i < converterTypes[selectedConversionType].length; i++) {
		    
		        var tempTypeData = converterTypes[selectedConversionType][i].split(',');
		        
		        objectFromDropDown.options[i] = new Option(tempTypeData[0],tempTypeData[1]);
		        objectToDropDown.options[i]	= new Option(tempTypeData[0],tempTypeData[1]);
		    }
	    }
	    
	    changeContext();
	}	
}

/**
* Validates input entry
*/
function handleChangeValueInput(textInputValue){

	var tempInputValue = trim(textInputValue.toUpperCase());
	settingsValueInput.value = tempInputValue;
	isAlreadyEdited = false;

	if ((selectedInputValue != tempInputValue) || !isValidInput ) {
		
		selectedInputValue = tempInputValue;
		
		if (isValidHex(selectedInputValue) || isValidDec(selectedInputValue) || selectedInputValue == "") {

			document.getElementById("result").innerHTML="";
			isValidInput = true;
		}
		else {		
		
			isValidInput = false;
			document.getElementById("result").innerHTML= ERR_INVALID_INPUT;
			settingsValueInput.focus();
		}
		
		changeContext();		
	}
}

function handleOnKeyDownValueInput(event, settingsValueInput) {

	var tempInputValue = trim(settingsValueInput.value.toUpperCase());
	
	//println("selectedInputValue= '" + selectedInputValue + "' KeyCode:" + event.keyCode );
	
	if ((tempInputValue == selectedInputValue) && (!isAlreadyEdited) && (event.keyCode == KEY_CODE_CENTER))	{
		settingsValueInput.value = "";
		document.getElementById("result").innerHTML = "";
		isAlreadyEdited = true; 
	} 
}

/**
* Handle From DropDown 
*/
function handleOnChangeFromDropDown(newIndexFromDrop) {

	//println("From antigo:'"+ selectedIndexFromDrop + "'  atual:'" + newIndexFromDrop + "'");
	
    if (selectedIndexFromDrop != newIndexFromDrop) {
        
        selectedIndexFromDrop = newIndexFromDrop;     
        if ( isValidInput ) document.getElementById("result").innerHTML = "";
        changeContext();
    }
}

/**
* Handle To DropDown 
*/
function handleOnChangeToDropDown(newIndexToDrop) {

	//println("To antigo:'"+ selectedIndexToDrop + "'  atual:'" + newIndexToDrop + "'");
	
    if (selectedIndexToDrop != newIndexToDrop) {
        
        selectedIndexToDrop = newIndexToDrop;
        if ( isValidInput ) document.getElementById("result").innerHTML = "";
        changeContext();
    }
}

/**
* Calculates the conversion. Called by Calculate menu    
*/
function settingsCalculate() {
	
	//println("TO: "+ selectedIndexToDrop + " FROM:" + selectedIndexFromDrop);
	
	selectedIndexFromDrop = settingsFromDropDown.selectedIndex;
	selectedIndexToDrop = settingsToDropDown.selectedIndex;
	selectedInputValue = settingsValueInput.value;
	
	var tempOutputValue=0;
	var textFromDrop = settingsFromDropDown.options[selectedIndexFromDrop].text;
	var textToDrop = settingsToDropDown.options[selectedIndexToDrop].text;
	var tempInputValue = trim(selectedInputValue);
	
	// changes context
	//loadMenu("reset");
	loadMenu("default");
	
    switch(selectedConversionType){
		case TYPE_TEMPERATURE:
			tempOutputValue = convertTemperature (textFromDrop, textToDrop, tempInputValue);
			break;
		
		case TYPE_NUMBER_BASE:
			tempOutputValue = convertNumberBase (textFromDrop, textToDrop, tempInputValue);
			break;
			
    	default:
			var valueFromDrop = settingsFromDropDown.options[selectedIndexFromDrop].value;
			var valueToDrop = settingsToDropDown.options[selectedIndexToDrop].value;
    		tempOutputValue = commonConverter (valueFromDrop, valueToDrop, tempInputValue);
    		break;
	}
	
	document.getElementById("result").innerHTML = tempOutputValue;
	settingsValueInput.focus();
}


/**
* Resets screen contents. Called by Reset menu 

function resultReset() {

	selectedConversionType = '';
	selectedIndexFromDrop =  '';
	selectedIndexToDrop =  '';
	selectedInputValue = '';
	isValidInput = true;

	loadMenu("default");
	
	document.getElementById("settingsTypeDropDown").selectedIndex = 0;
	document.getElementById("settingsValueInput").value = "";
	document.getElementById("settingsFromDropDown").selectedIndex = 0;
	document.getElementById("settingsToDropDown").selectedIndex = 0;
	document.getElementById("result").innerHTML = "";
	document.getElementById("settingsTypeDropDown").focus();
}*/
	
